; -------------------------
; -      boot-loader      -  
; - uses trackdisk.device -
; - by Snoopy/Level 4-ASD -
; -       for DISC!       -
; -------------------------

 ORG  $70000
 LOAD $70000

 DC.B "DOS",0                          ;dos kennzeichen
 DC.L 0                                ;checksumme (mit cmon berechnen)
 DC.L $370                             ;root-block

 lea     DOSName(pc),a1
 move.l	 $4,a6
 jsr	 -96(a6)
 tst.l   d0
 bne.s   booted
 reset
booted:
 move.l  d0,a0
 move.l  22(a0),a0
 moveq   #0,d0

bsr.s	inittrd
bsr.s	io
bsr.L	quittrd
move.w	#$83e0,$dff096
jsr	$50000
jmp	$fc00d2

IO:	lea	diskio(pc),a1
	move.w	#2,28(a1)
	move.l	#$50000,40(a1)
	move.l	#$5000,36(a1)
	move.l	#11*512,44(a1)
	move.l	4,a6
	jsr	-456(a6)
	lea	diskio(pc),a1
	move.w	#4,28(a1)
	move.l	4,a6
	jsr	-456(a6)
	rts

Inittrd:
	move.l	4,a6

	sub.l	a1,a1
	jsr	-294(a6)
	lea 	diskrep(pc),a5
	move.l	d0,16(a5)
	lea	diskrep(pc),a1
	jsr	-354(a6)

	lea	diskio(pc),a1
	lea	diskrep(pc),a5
	move.l	a5,14(a1)
	clr.l	d0
	clr.l	d1
	lea	trd(pc),a0
	jsr	-444(a6)
	tst.l	d0
	bne.s	error
	rts

quittrd:
	move.l	4,a6
	lea	diskio(pc),a1
	move.l	32(a1),d7
	move.w	#9,28(a1)
	move.l	#0,36(a1)
	jsr	-456(a6)
	move.l	4,a6
	lea	diskio(pc),a1
	jsr	-450(a6)
	lea	diskrep(pc),a1
	jsr	-360(a6)
error:	clr.l	d0
	rts

trd:		dc.b  "trackdisk.device",0
DOSName:	dc.b  "dos.library",0
even
diskio:		dc.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
diskrep:	dc.l 0,0,0,0,0,0,0,0
